diff -uNr src.ORIG/mclibs/herwig/code/hwbran.F src/mclibs/herwig/code/hwbran.F
--- src.ORIG/mclibs/herwig/code/hwbran.F	1996-12-03 23:16:47.000000000 +0900
+++ src/mclibs/herwig/code/hwbran.F	2005-05-31 02:34:39.000000000 +0900
@@ -8,6 +8,9 @@
 C     INTO NPAR+1 AND NPAR+2, AND INCREASES NPAR BY TWO
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWBVMC,HWRGEN,HWUALF,HWUTAB,HWRUNI,HWULDO,PMOM,
      & QNOW,QLST,QKTHR,RN,QQBAR,DQQ,QGTHR,SNOW,QSUD,ZMIN,ZMAX,ZRAT,WMIN,
      & QLAM,Z1,Z2,ETEST,ZTEST,ENOW,XI,XIPREV,EPREV,QMAX,QGAM,SLST,SFNL,
@@ -24,8 +27,14 @@
       IF (SUDORD.NE.1.AND.BETA0(3).EQ.ZERO) THEN
         DO 100 M=3,6
           BETA0(M)=(11.*CAFAC-2.*M)*0.5
+#if !defined(CERNLIB_GFORTRAN)
  100      BETAP(M)=(17.*CAFAC**2-(5.*CAFAC+3.*CFFAC)*M)
      &            /BETA0(M)*0.25/PIFAC
+#else
+            BETAP(M)=(17.*CAFAC**2-(5.*CAFAC+3.*CFFAC)*M)
+     &            /BETA0(M)*0.25/PIFAC
+ 100      continue
+#endif
         DO 120 N=1,5
           DO 110 M=4,6
             IF (M.LE.N) THEN
@@ -106,7 +115,14 @@
         ENDIF
         NTRY=0
     5   NTRY=NTRY+1
+#if !defined(CERNLIB_GFORTRAN)
         IF (NTRY.GT.NBTRY) CALL HWWARN('HWBRAN',100,*999)
+#else
+        if (NTRY.GT.NBTRY) then
+          call hwwarn('HWBRAN',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         IF (ID.EQ.13) THEN
 C--GLUON -> QUARK+ANTIQUARK OPTION
           IF (QLST.GT.QCDL3) THEN
@@ -118,8 +134,13 @@
 C---FIND IN WHICH FLAVOUR INTERVAL THE UPPER LIMIT LIES
                 NF=3
                 DO 200 M=MAX(3,N),NFLAV
+#if !defined(CERNLIB_GFORTRAN)
  200              IF (QLST.GT.RMASS(M)) NF=M
 C---CALCULATE THE FORM FACTOR
+#else
+                    IF (QLST.GT.RMASS(M)) NF=M
+ 200              continue
+#endif
                 IF (NF.EQ.MAX(3,N)) THEN
                   SFNL=((BETAP(NF)+1/HWUALF(1,QKTHR))/
      $                 (BETAP(NF)+1/HWUALF(1,QLST)))**(1/BETA0(NF))
@@ -142,7 +163,12 @@
                 ELSEIF (RN.GE.SLST) THEN
                   NN=MAX(3,N)
                   DO 210 M=MAX(3,N)+1,NF-1
+#if !defined(CERNLIB_GFORTRAN)
  210                IF (RN.GE.SLST/SQRK(M,N)) NN=M
+#else
+                      IF (RN.GE.SLST/SQRK(M,N)) NN=M
+ 210                continue
+#endif
                 ELSE
                   NN=0
                   QQBAR=QCDL3
@@ -160,7 +186,14 @@
                   ALF=HWUALF(1,QQBAR)
                   IF (ABS(ALF-TARG).GT.ACCUR) THEN
                     NTRY=NTRY+1
+#if !defined(CERNLIB_GFORTRAN)
                     IF (NTRY.GT.NBTRY) CALL HWWARN('HWBRAN',101,*999)
+#else
+                    if (NTRY.GT.NBTRY) then
+          call hwwarn('HWBRAN',101,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
                     QQBAR=QQBAR*(1+3*PIFAC*(ALF-TARG)
      $                   /(BETA0(NN)*ALF**2*(1+BETAP(NN)*ALF)))
                     GOTO 7
@@ -212,7 +245,12 @@
               SNOW=HWUTAB(SUD(1,IS),QEV(1,IS),NQEV,QLST,1)/RN
               QSUD=HWUTAB(QEV(1,IS),SUD(1,IS),NQEV,SNOW,1)
               IF (QSUD.GT.QLST) THEN
+#if !defined(CERNLIB_GFORTRAN)
                 CALL HWWARN('HWBRAN',1,*999)
+#else
+                call hwwarn('HWBRAN',1,iret)
+        if (iret .eq. 1) go to 999
+#endif
                 QSUD=-1
               ENDIF
             ENDIF
@@ -416,7 +454,14 @@
           PPAR(5,KPAR)=PPAR(1,2)**2
           PMOM=0
         ENDIF
+#if !defined(CERNLIB_GFORTRAN)
         IF (PMOM.LT.-1E-6) CALL HWWARN('HWBRAN',104,*999)
+#else
+        if (PMOM.LT.-1E-6) then
+          call hwwarn('HWBRAN',104,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         IF (PMOM.LT.0) PMOM=0
         PPAR(3,KPAR)=SQRT(PMOM)
         JDAPAR(1,KPAR)=0
diff -uNr src.ORIG/mclibs/herwig/code/hwbsud.F src/mclibs/herwig/code/hwbsud.F
--- src.ORIG/mclibs/herwig/code/hwbsud.F	1996-12-03 23:16:48.000000000 +0900
+++ src/mclibs/herwig/code/hwbsud.F	2005-05-31 02:34:39.000000000 +0900
@@ -7,6 +7,9 @@
 C     COMPUTES (OR READS) TABLES OF SUDAKOV FORM FACTORS
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWUGAU,HWBVMC,HWBSUG,HWBSU1,HWBSU2,G1,G2,QRAT,
      & QLAM,POWER,AFAC,QMIN,QFAC,QNOW,ZMIN,ZMAX,Q1,QCOLD,VGOLD,VQOLD,
      & RMOLD(6),ACOLD,ZLO,ZHI
@@ -36,7 +39,12 @@
           IF (ZHI.GT.ZLO) G1=G1+HWUGAU(HWBSUG,LOG(ZLO),LOG(ZHI),ACCUR)
     5   CONTINUE
         SUD(IQ,1)=EXP(AFAC*G1)
+#if !defined(CERNLIB_GFORTRAN)
    10   QEV(IQ,1)=QNOW
+#else
+           QEV(IQ,1)=QNOW
+   10   continue
+#endif
         AFAC=3.*CFFAC/BETAF
 C--QUARK FORM FACTORS.
 C--IS=2,3,4,5,6,7 FOR U/D,S,C,B,T,V
@@ -74,7 +82,12 @@
           IF (ZHI.GT.ZLO) G2=G2+HWUGAU(HWBSU2,ZLO,ZHI,ACCUR)
    13   CONTINUE
         SUD(IQ,IS)=EXP(AFAC*(G1+G2))
+#if !defined(CERNLIB_GFORTRAN)
    14   QEV(IQ,IS)=QNOW
+#else
+           QEV(IQ,IS)=QNOW
+   14   continue
+#endif
    15   CONTINUE
         QCOLD=QCDLAM
         VGOLD=VGCUT
@@ -87,7 +100,12 @@
         NFOLD=NFLAV
         SDOLD=SUDORD
         DO 16 IS=1,NSUD
+#if !defined(CERNLIB_GFORTRAN)
    16   RMOLD(IS)=RMASS(IS)
+#else
+           RMOLD(IS)=RMASS(IS)
+   16   continue
+#endif
       ELSE
         IF (LRSUD.GT.0) THEN
           IF (IPRINT.NE.0) WRITE (6,17) LRSUD
@@ -98,22 +116,102 @@
           CLOSE(UNIT=LRSUD)
         ENDIF
 C---CHECK THAT RELEVANT PARAMETERS ARE UNCHANGED
+#if !defined(CERNLIB_GFORTRAN)
         IF (QCDLAM.NE.QCOLD) CALL HWWARN('HWBSUD',501,*999)
+#else
+        if (QCDLAM.NE.QCOLD) then
+          call hwwarn('HWBSUD',501,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
+#if !defined(CERNLIB_GFORTRAN)
         IF (VGCUT .NE.VGOLD) CALL HWWARN('HWBSUD',502,*999)
+#else
+        if (VGCUT .NE.VGOLD) then
+          call hwwarn('HWBSUD',502,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
+#if !defined(CERNLIB_GFORTRAN)
         IF (VQCUT .NE.VQOLD) CALL HWWARN('HWBSUD',503,*999)
+#else
+        if (VQCUT .NE.VQOLD) then
+          call hwwarn('HWBSUD',503,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
+#if !defined(CERNLIB_GFORTRAN)
         IF (ACCUR .NE.ACOLD) CALL HWWARN('HWBSUD',504,*999)
+#else
+        if (ACCUR .NE.ACOLD) then
+          call hwwarn('HWBSUD',504,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
+#if !defined(CERNLIB_GFORTRAN)
         IF (INTER .NE.INOLD) CALL HWWARN('HWBSUD',505,*999)
+#else
+        if (INTER .NE.INOLD) then
+          call hwwarn('HWBSUD',505,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
+#if !defined(CERNLIB_GFORTRAN)
         IF (NQEV  .NE.NQOLD) CALL HWWARN('HWBSUD',506,*999)
+#else
+        if (NQEV  .NE.NQOLD) then
+          call hwwarn('HWBSUD',506,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
+#if !defined(CERNLIB_GFORTRAN)
         IF (NSUD  .NE.NSOLD) CALL HWWARN('HWBSUD',507,*999)
+#else
+        if (NSUD  .NE.NSOLD) then
+          call hwwarn('HWBSUD',507,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
+#if !defined(CERNLIB_GFORTRAN)
         IF (NCOLO .NE.NCOLD) CALL HWWARN('HWBSUD',508,*999)
+#else
+        if (NCOLO .NE.NCOLD) then
+          call hwwarn('HWBSUD',508,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
+#if !defined(CERNLIB_GFORTRAN)
         IF (NFLAV .NE.NFOLD) CALL HWWARN('HWBSUD',509,*999)
+#else
+        if (NFLAV .NE.NFOLD) then
+          call hwwarn('HWBSUD',509,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
+#if !defined(CERNLIB_GFORTRAN)
         IF (SUDORD.NE.SDOLD) CALL HWWARN('HWBSUD',510,*999)
+#else
+        if (SUDORD.NE.SDOLD) then
+          call hwwarn('HWBSUD',510,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
 C---CHECK MASSES AND THAT TABLES ARE BIG ENOUGH FOR THIS RUN
         DO 18 IS=1,NSUD
           IF (RMASS(IS).NE.RMOLD(IS))
+#if !defined(CERNLIB_GFORTRAN)
      &      CALL HWWARN('HWBSUD',510+IS,*999)
+#else
+     &      call hwwarn('HWBSUD',510+IS,iret)
+        if (iret .eq. 1) go to 999
+#endif
           IF (QEV(NQEV,IS).LT.QLIM.AND.HWBVMC(IS)+QG.LT.QLIM)
+#if !defined(CERNLIB_GFORTRAN)
      &      CALL HWWARN('HWBSUD',500,*999)
+#else
+     &      call hwwarn('HWBSUD',500,iret)
+        if (iret .eq. 1) go to 999
+#endif
    18   CONTINUE
       ENDIF
       IF (LWSUD.GT.0) THEN
diff -uNr src.ORIG/mclibs/herwig/code/hwbtim.F src/mclibs/herwig/code/hwbtim.F
--- src.ORIG/mclibs/herwig/code/hwbtim.F	1996-12-03 23:16:48.000000000 +0900
+++ src/mclibs/herwig/code/hwbtim.F	2005-05-31 02:34:20.000000000 +0900
@@ -12,6 +12,9 @@
 C     Ses Nucl. Phys. B304 (1988) 794 & Comp. Phys. Comm. 58 (1990) 271.
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,DMIN,PT,EIKON,EINUM,EIDEN1,EIDEN2,EISCR,
      & WT,SPIN,Z1,Z2,PRMAX,CAZ,CX,SX,ROHEP(3),RMAT(3,3),ZERO2(2)
       INTEGER INITBR,INTERF,IPAR,JPAR,KPAR,LPAR,MPAR,NTRY,JOLD
@@ -37,7 +40,12 @@
       ELSE
          KPAR=JPAR-1
          IF (JMOPAR(1,KPAR).NE.IPAR)
+#if !defined(CERNLIB_GFORTRAN)
      &   CALL HWWARN('HWBTIM',100,*999)
+#else
+     &   call hwwarn('HWBTIM',100,iret)
+        if (iret .eq. 1) go to 999
+#endif
 C        Generate Rho''
          CALL HWBAZF(IPAR,KPAR,RHOPAR(1,IPAR),PHIPAR(1,IPAR),
      &                         DECPAR(1,KPAR),RHOPAR(1,JPAR))
@@ -94,7 +102,14 @@
          PRMAX=(1.+ABS(WT))*EIKON
          NTRY=0
    50    NTRY=NTRY+1
+#if !defined(CERNLIB_GFORTRAN)
          IF (NTRY.GT.NBTRY) CALL HWWARN('HWBTIM',101,*999)
+#else
+         if (NTRY.GT.NBTRY) then
+          call hwwarn('HWBTIM',101,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
          CALL HWRAZM( ONE,CX,SX)
          CALL HWUROT(PPAR(1,JPAR),CX,SX,RMAT)
 C Determine the angle between the branching planes
diff -uNr src.ORIG/mclibs/herwig/code/hwccut.F src/mclibs/herwig/code/hwccut.F
--- src.ORIG/mclibs/herwig/code/hwccut.F	1996-12-03 23:16:48.000000000 +0900
+++ src/mclibs/herwig/code/hwccut.F	2005-05-31 02:34:39.000000000 +0900
@@ -98,7 +98,12 @@
       CALL HWULOB(PC,PA,PB)
       CALL HWULOB(PCL,PB,PHEP(1,LHEP))
       DO 50 J=1,4
+#if !defined(CERNLIB_GFORTRAN)
   50  PHEP(J,JHEP)=PCL(J)-PHEP(J,KHEP)-PHEP(J,LHEP)-PHEP(J,MHEP)
+#else
+         PHEP(J,JHEP)=PCL(J)-PHEP(J,KHEP)-PHEP(J,LHEP)-PHEP(J,MHEP)
+  50  continue
+#endif
       PHEP(5,JHEP)=QM1
       CALL HWVEQU(4,VHEP(1,LHEP),VHEP(1,MHEP))
 C Construct new vertex positions
diff -uNr src.ORIG/mclibs/herwig/code/hwcdec.F src/mclibs/herwig/code/hwcdec.F
--- src.ORIG/mclibs/herwig/code/hwcdec.F	1996-12-03 23:16:48.000000000 +0900
+++ src/mclibs/herwig/code/hwcdec.F	2005-05-31 02:34:20.000000000 +0900
@@ -7,6 +7,9 @@
 C     DECAYS CLUSTERS INTO PRIMARY HADRONS
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       INTEGER JCL,KCL,IP,JP,KP,IST,ID1,ID2,ID3
       IF (IERROR.NE.0) RETURN
       IF (IPROC/1000.EQ.9.OR.IPROC/1000.EQ.5) THEN
@@ -27,7 +30,12 @@
             IP=JDAHEP(2,KP)
           ENDIF
           KCL=JDAHEP(1,IP)
+#if !defined(CERNLIB_GFORTRAN)
           IF (ISTHEP(KCL)/10.NE.16) CALL HWWARN('HWCDEC',100,*999)
+#else
+          IF (ISTHEP(KCL)/10.NE.16) call hwwarn('HWCDEC',100,iret)
+        if (iret .eq. 1) go to 999
+#endif
           ISTHEP(KCL)=164
           GOTO 20
         ENDIF
diff -uNr src.ORIG/mclibs/herwig/code/hwcfor.F src/mclibs/herwig/code/hwcfor.F
--- src.ORIG/mclibs/herwig/code/hwcfor.F	1996-12-03 23:16:48.000000000 +0900
+++ src/mclibs/herwig/code/hwcfor.F	2005-05-31 02:34:39.000000000 +0900
@@ -9,6 +9,9 @@
 C     MHS's cluster vertices
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWULDO,HWVDOT,HWRGEN,HWUPCM,DCL0,DCL(4),DCL1,
      & DFAC,DISP1(4),DISP2(4),DMAX,PCL(5),DOT1,DOT2,FAC,VCLUS,SCA1,SCA2,
      & EM0,EM1,EM2,PC0,PC1
@@ -30,7 +33,12 @@
       IF (IERROR.NE.0) RETURN
 C Look for partons to cluster
       DO 10 IBHEP=1,NHEP
+#if !defined(CERNLIB_GFORTRAN)
   10  IF (ISTHEP(IBHEP).GE.150.AND.ISTHEP(IBHEP).LE.154) GOTO 20
+#else
+         IF (ISTHEP(IBHEP).GE.150.AND.ISTHEP(IBHEP).LE.154) GOTO 20
+  10  continue
+#endif
       IBCL=1
       GOTO 130
 C Allow for clour rearrangement of primary clusters
@@ -88,7 +96,12 @@
         IF (JHEP.NE.JBHEP) GOTO 30
         IF (NRECO.NE.0) THEN
           DO 50 IHEP=IBHEP,NHEP
+#if !defined(CERNLIB_GFORTRAN)
   50      JDAHEP(2,IHEP)=ABS(JDAHEP(2,IHEP))
+#else
+             JDAHEP(2,IHEP)=ABS(JDAHEP(2,IHEP))
+  50      continue
+#endif
         ENDIF
       ENDIF
 C Find (adjusted) cluster positions using MHS prescription
@@ -140,8 +153,14 @@
         SCA1=MAX(ONE,ONE+FAC)
         SCA2=MAX(ONE,ONE-FAC)
         DO 60 I=1,4
+#if !defined(CERNLIB_GFORTRAN)
   60    VCLUS(I,JHEP)=.5*(VHEP(I,JHEP)+VHEP(I,KHEP)
      &                   +SCA1*DISP1(I)+SCA2*DISP2(I))
+#else
+           VCLUS(I,JHEP)=.5*(VHEP(I,JHEP)+VHEP(I,KHEP)
+     &                   +SCA1*DISP1(I)+SCA2*DISP2(I))
+  60    continue
+#endif
       ENDIF
   70  CONTINUE
 C First chop up beam/target clusters
@@ -229,7 +248,12 @@
       IF (LCL.GT.NHEP) LCL=LCL-MCL
       IF (LCL.EQ.JCL) THEN
         IF (EM0.GE.EM1+RMIN(1,1)) GOTO 150
+#if !defined(CERNLIB_GFORTRAN)
         CALL HWWARN('HWCFOR',101,*999)
+#else
+        call hwwarn('HWCFOR',101,iret)
+        if (iret .eq. 1) go to 999
+#endif
       ENDIF
       IF (ISTHEP(LCL).LT.163.OR.ISTHEP(LCL).GT.165) GOTO 140
 C Rescale momenta in 2-cluster CoM
@@ -260,10 +284,20 @@
         CALL HWDTWO(PCL,PHEP(1,JCL),PHEP(1,LCL),PC1,TWO,.TRUE.)
         GOTO 150
       ELSE
+#if !defined(CERNLIB_GFORTRAN)
         CALL HWWARN('HWCFOR',102,*999)
+#else
+        call hwwarn('HWCFOR',102,iret)
+        if (iret .eq. 1) go to 999
+#endif
       ENDIF
   140 CONTINUE
+#if !defined(CERNLIB_GFORTRAN)
       CALL HWWARN('HWCFOR',103,*999)
+#else
+      call hwwarn('HWCFOR',103,iret)
+        if (iret .eq. 1) go to 999
+#endif
   150 CONTINUE
       ISTAT=60
 C Non-partons labelled as partons (ie photons) should get copied
diff -uNr src.ORIG/mclibs/herwig/code/hwcgsp.F src/mclibs/herwig/code/hwcgsp.F
--- src.ORIG/mclibs/herwig/code/hwcgsp.F	1996-12-03 23:16:49.000000000 +0900
+++ src/mclibs/herwig/code/hwcgsp.F	2005-05-31 02:34:39.000000000 +0900
@@ -8,10 +8,20 @@
 C     BRANCHING INTO LIGHT (I.E. U OR D) Q-QBAR PAIRS
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,PF
       INTEGER HWRINT,IHEP,JHEP,KHEP,LHEP,MHEP,ID,J,IST
       EXTERNAL HWRGEN,HWRINT
+#if !defined(CERNLIB_GFORTRAN)
       IF (NGSPL.EQ.0) CALL HWWARN('HWCGSP',400,*999)
+#else
+      if (NGSPL.EQ.0) then
+          call hwwarn('HWCGSP',400,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       LHEP=NHEP-1
       MHEP=NHEP
       DO 100 IHEP=1,NHEP
@@ -21,13 +31,28 @@
         IF (ISTHEP(JHEP).EQ.155) THEN
           JHEP=JDAHEP(1,JDAHEP(2,JHEP))
           DO 10 J=JDAHEP(1,JHEP),JDAHEP(2,JHEP)
+#if !defined(CERNLIB_GFORTRAN)
   10      IF (ISTHEP(J).EQ.149.AND.JDAHEP(2,J).EQ.0) GOTO 20
+#else
+             IF (ISTHEP(J).EQ.149.AND.JDAHEP(2,J).EQ.0) GOTO 20
+  10      continue
+#endif
+#if !defined(CERNLIB_GFORTRAN)
           CALL HWWARN('HWCGSP',100,*999)
+#else
+          call hwwarn('HWCGSP',100,iret)
+        if (iret .eq. 1) go to 999
+#endif
   20      JHEP=J
         ENDIF
         KHEP=JDAHEP(2,IHEP)
 C---CHECK FOR DECAYED HEAVY QUARKS
+#if !defined(CERNLIB_GFORTRAN)
         IF (ISTHEP(KHEP).EQ.155)  CALL HWWARN('HWCGSP',101,*999)
+#else
+        IF (ISTHEP(KHEP).EQ.155)  call hwwarn('HWCGSP',101,iret)
+        if (iret .eq. 1) go to 999
+#endif
         IF (IDHW(IHEP).EQ.13) THEN
 C---SPLIT A GLUON
           LHEP=LHEP+2
diff -uNr src.ORIG/mclibs/herwig/code/hwchad.F src/mclibs/herwig/code/hwchad.F
--- src.ORIG/mclibs/herwig/code/hwchad.F	1996-12-03 23:16:49.000000000 +0900
+++ src/mclibs/herwig/code/hwchad.F	2005-05-31 02:34:20.000000000 +0900
@@ -9,6 +9,9 @@
 C     (IN SPECIAL CLUSTER CODE - SEE HWCFLA)
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,EM0,EM1,EM2,EMADU,EMSQ,PCMAX,PCM,PTEST,
      & PCQK,PP(5),EMLOW,RMAT(3,3),CT,ST,CX,SX
       INTEGER HWRINT,JCL,ID1,ID2,ID3,ID,IR1,IR2,NTRY,IDMIN,IMAX,I,MHEP,
@@ -24,7 +27,14 @@
       IF (ABS(EM0-EM1).LT.0.001) THEN
 C---SINGLE-HADRON CLUSTER
         NHEP=NHEP+1
+#if !defined(CERNLIB_GFORTRAN)
         IF (NHEP.GT.NMXHEP) CALL HWWARN('HWCHAD',100,*999)
+#else
+        if (NHEP.GT.NMXHEP) then
+          call hwwarn('HWCHAD',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         IDHW(NHEP)=IR1
         IDHEP(NHEP)=IDPDG(IR1)
         ISTHEP(NHEP)=191
@@ -80,7 +90,12 @@
           IF (PCM.GT.0.) GOTO 70
           NTRY=NTRY+1
           IF (NTRY.LE.NDTRY+50) GOTO 60
+#if !defined(CERNLIB_GFORTRAN)
           CALL HWWARN('HWCHAD',101,*999)
+#else
+          call hwwarn('HWCHAD',101,iret)
+        if (iret .eq. 1) go to 999
+#endif
 C---DECAY IS ALLOWED
   70      PCM=PCM*(EMSQ-(EM1-EM2)**2)
           IF (NTRY.GT.NCTRY) GOTO 80
@@ -95,11 +110,25 @@
         ENDIF
 C---DECAY IS CHOSEN.  GENERATE DECAY MOMENTA
 C   AND PUT PARTICLES IN /HEPEVT/
+#if !defined(CERNLIB_GFORTRAN)
   80    IF (PCM.LT.0.) CALL HWWARN('HWCHAD',102,*999)
+#else
+  80    if (PCM.LT.0.) then
+          call hwwarn('HWCHAD',102,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         PCM=0.5*SQRT(PCM)/EM0
         MHEP=NHEP+1
         NHEP=NHEP+2
+#if !defined(CERNLIB_GFORTRAN)
         IF (NHEP.GT.NMXHEP) CALL HWWARN('HWCHAD',103,*999)
+#else
+        if (NHEP.GT.NMXHEP) then
+          call hwwarn('HWCHAD',103,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         PHEP(5,MHEP)=EM1
         PHEP(5,NHEP)=EM2
         IF (CLDIR.NE.0) THEN
diff -uNr src.ORIG/mclibs/herwig/code/hwdbos.F src/mclibs/herwig/code/hwdbos.F
--- src.ORIG/mclibs/herwig/code/hwdbos.F	1996-12-03 23:16:49.000000000 +0900
+++ src/mclibs/herwig/code/hwdbos.F	2005-05-31 02:34:21.000000000 +0900
@@ -10,13 +10,21 @@
 C     IF BOSON CAME FROM W+1JET, GIVE IT THE CORRECT DECAY CORRELATIONS
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,HWRUNI,HWUPCM,HWULDO,R(3,3),CV,CA,BR,PCM,
      & PBOS(5),PMAX,PROB,RRLL,RLLR
       INTEGER HWRINT,IBOS,IPAIR,ICMF,IOPT,IHEL,IMOTH,I,IQRK,IANT,ID,IQ
       LOGICAL QUARKS
       EXTERNAL HWRGEN,HWRUNI,HWUPCM,HWULDO,HWRINT
       IF (IDHW(IBOS).LT.198.OR.IDHW(IBOS).GT.200)
+#if !defined(CERNLIB_GFORTRAN)
      &  CALL HWWARN('HWDBOS',101,*999)
+#else
+     &  call hwwarn('HWDBOS',101,iret)
+        if (iret .eq. 1) go to 999
+#endif
       QUARKS=.FALSE.
 C---SEE IF IT IS PART OF A PAIR
       IMOTH=JMOHEP(1,IBOS)
@@ -58,7 +66,14 @@
         PHEP(5,NHEP+1)=RMASS(IDN(1))
         PHEP(5,NHEP+2)=RMASS(IDN(2))
         PCM=HWUPCM(PHEP(5,IBOS),PHEP(5,NHEP+1),PHEP(5,NHEP+2))
+#if !defined(CERNLIB_GFORTRAN)
         IF (PCM.LT.0) CALL HWWARN('HWDBOS',103,*999)
+#else
+        if (PCM.LT.0) then
+          call hwwarn('HWDBOS',103,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         IF (IDHW(IBOS).EQ.200) THEN
           ID=IDN(1)
           IF (ID.GT.120) ID=ID-110
@@ -85,7 +100,14 @@
      &             HWULDO(PHEP(1,IQRK),PHEP(1,NHEP+2))**2)+
      &       RLLR*(HWULDO(PHEP(1,IANT),PHEP(1,NHEP+2))**2+
      &             HWULDO(PHEP(1,IQRK),PHEP(1,NHEP+1))**2)
+#if !defined(CERNLIB_GFORTRAN)
         IF (PROB.GT.PMAX.OR.PROB.LT.0) CALL HWWARN('HWDBOS',104,*999)
+#else
+        if (PROB.GT.PMAX.OR.PROB.LT.0) then
+          call hwwarn('HWDBOS',104,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         IF (PMAX*HWRGEN(0).GT.PROB) GOTO 1
       ELSE
 C---SELECT HELICITY, UNLESS IT IS THE SECOND OF A HIGGS DECAY (EPR)
@@ -97,7 +119,12 @@
           IF (RHOHEP(1,IBOS)+RHOHEP(2,IBOS)+RHOHEP(3,IBOS).GT.0)
      &    GOTO 20
         ENDIF
+#if !defined(CERNLIB_GFORTRAN)
         CALL HWWARN('HWDBOS',1,*999)
+#else
+        call hwwarn('HWDBOS',1,iret)
+        if (iret .eq. 1) go to 999
+#endif
         RHOHEP(1,IBOS)=1.
         RHOHEP(2,IBOS)=1.
         RHOHEP(3,IBOS)=1.
@@ -114,7 +141,14 @@
       PHEP(5,NHEP+1)=RMASS(IDN(1))
       PHEP(5,NHEP+2)=RMASS(IDN(2))
       PCM=HWUPCM(PHEP(5,IBOS),PHEP(5,NHEP+1),PHEP(5,NHEP+2))
+#if !defined(CERNLIB_GFORTRAN)
       IF (PCM.LT.0) CALL HWWARN('HWDBOS',102,*999)
+#else
+      if (PCM.LT.0) then
+          call hwwarn('HWDBOS',102,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       CALL HWRAZM(PCM*SQRT(1-COSTH**2),PHEP(1,NHEP+1),PHEP(2,NHEP+1))
       PHEP(3,NHEP+1)=PCM*COSTH
       PHEP(4,NHEP+1)=SQRT(PHEP(5,NHEP+1)**2+PCM**2)
diff -uNr src.ORIG/mclibs/herwig/code/hwdboz.F src/mclibs/herwig/code/hwdboz.F
--- src.ORIG/mclibs/herwig/code/hwdboz.F	1996-12-03 23:16:50.000000000 +0900
+++ src/mclibs/herwig/code/hwdboz.F	2005-05-31 02:34:39.000000000 +0900
@@ -8,6 +8,9 @@
 C     IOPT=2 TO RESET COUNTERS, 1 FOR BOSON PAIR, 0 FOR ANY OTHERS
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,BRMODE(12,3),CV,CA,BR,BRLST,BRCOM,FACZ,
      & FACW
       INTEGER HWRINT,IDBOS,IDEC,IDMODE(2,12,3),IFER,IANT,IOPT,I1,I2,
@@ -32,7 +35,14 @@
       DATA FACW,FACZ/2*0.0/
       IF (FACZ.EQ.0) FACZ=SQRT(SWEIN)
       IF (FACW.EQ.0) FACW=0.5/SQRT(2D0)
+#if !defined(CERNLIB_GFORTRAN)
       IF (IDBOS.LT.198.OR.IDBOS.GT.200) CALL HWWARN('HWDBOZ',101,*999)
+#else
+      if (IDBOS.LT.198.OR.IDBOS.GT.200) then
+          call hwwarn('HWDBOZ',101,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
 C---IF THIS IS A NEW EVENT SINCE LAST TIME, ZERO COUNTERS
       IF (NWGTS.NE.NWGLST .OR.(GENEV.NEQV.GENLST).OR. IOPT.EQ.2) THEN
         NPAIR=0
@@ -42,10 +52,24 @@
         IF (IOPT.EQ.2) RETURN
       ENDIF
       NUMDEC=NUMDEC+1
+#if !defined(CERNLIB_GFORTRAN)
       IF (NUMDEC.GT.MODMAX) CALL HWWARN('HWDBOZ',102,*999)
+#else
+      if (NUMDEC.GT.MODMAX) then
+          call hwwarn('HWDBOZ',102,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
 C---IF PAIR OPTION SPECIFIED FOR THE FIRST TIME, MAKE CHOICE
       IF (IOPT.EQ.1) THEN
+#if !defined(CERNLIB_GFORTRAN)
         IF (NUMDEC.GT.MODMAX-1) CALL HWWARN('HWDBOZ',103,*999)
+#else
+        if (NUMDEC.GT.MODMAX-1) then
+          call hwwarn('HWDBOZ',103,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         IF (NPAIR.EQ.0) THEN
           IF (HWRGEN(1).GT.0.5) THEN
             MODTMP=MODBOS(NUMDEC+1)
@@ -113,7 +137,12 @@
 C   (RESULT IS NOT WELL-DEFINED AFTER THE FIRST CALL OF A PAIR)
       BR=0
       DO 20 IDEC=I1,I2
+#if !defined(CERNLIB_GFORTRAN)
  20     BR=BR+BRMODE(IDEC,IDBOS-197)
+#else
+           BR=BR+BRMODE(IDEC,IDBOS-197)
+ 20     continue
+#endif
       IF (IOPT.EQ.1) THEN
         IF (NPAIR.NE.0) THEN
           I1LST=I1
@@ -122,7 +151,12 @@
         ELSE
           BRCOM=0
           DO 30 IDEC=MAX(I1,I1LST),MIN(I2,I2LST)
+#if !defined(CERNLIB_GFORTRAN)
  30         BRCOM=BRCOM+BRMODE(IDEC,IDBOS-197)
+#else
+               BRCOM=BRCOM+BRMODE(IDEC,IDBOS-197)
+ 30         continue
+#endif
           BR=2*BR*BRLST - BRCOM**2
         ENDIF
       ENDIF
diff -uNr src.ORIG/mclibs/herwig/code/hwdcle.F src/mclibs/herwig/code/hwdcle.F
--- src.ORIG/mclibs/herwig/code/hwdcle.F	1996-12-03 23:16:53.000000000 +0900
+++ src/mclibs/herwig/code/hwdcle.F	2005-05-31 02:34:21.000000000 +0900
@@ -7,6 +7,9 @@
 C INTERFACE TO QQ-CLEO MONTE CARLO (LS 11/12/91)
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       INTEGER IHEP,IIHEP,NHEPHF,QQLMAT
       LOGICAL QQLERR
       CHARACTER*8 NAME
@@ -118,7 +121,14 @@
       IF(FSTEVT) THEN
 C---INITIALIZE QQ-CLEO
         CALL QQINIT(QQLERR)
+#if !defined(CERNLIB_GFORTRAN)
         IF(QQLERR) CALL HWWARN('HWDEUR',500,*999)
+#else
+        if (QQLERR) then
+          call hwwarn('HWDEUR',500,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       ENDIF
 C---CONSTRUCT THE HADRON FOR QQ-CLEO
 C NOTE: THE IDPDG CODE IS PROVIDED THROUGH THE QQLMAT ROUTINE
diff -uNr src.ORIG/mclibs/herwig/code/hwdeur.F src/mclibs/herwig/code/hwdeur.F
--- src.ORIG/mclibs/herwig/code/hwdeur.F	1996-12-03 23:16:53.000000000 +0900
+++ src/mclibs/herwig/code/hwdeur.F	2005-05-31 02:34:21.000000000 +0900
@@ -7,6 +7,9 @@
 C INTERFACE TO EURODEC PACKAGE (LS 10/29/91)
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       INTEGER IHEP,IIHEP,NHEPHF,IEUPDG,IPDGEU
       CHARACTER*8 NAME
 C---EURODEC COMMON'S : INITIAL INPUT
@@ -94,6 +97,13 @@
       VHEP(2,NHEP)=EUSECV(2,IIHEP)
       VHEP(3,NHEP)=EUSECV(3,IIHEP)
       VHEP(4,NHEP)=0.
+#if !defined(CERNLIB_GFORTRAN)
       IF (IIHEP.GT.NTMAX) CALL HWWARN('HWDEUR',99,*999)
+#else
+      if (IIHEP.GT.NTMAX) then
+          call hwwarn('HWDEUR',99,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
    40 CONTINUE
   999 END
diff -uNr src.ORIG/mclibs/herwig/code/hwdfiv.F src/mclibs/herwig/code/hwdfiv.F
--- src.ORIG/mclibs/herwig/code/hwdfiv.F	1996-12-03 23:16:53.000000000 +0900
+++ src/mclibs/herwig/code/hwdfiv.F	2005-05-31 02:34:21.000000000 +0900
@@ -12,7 +12,14 @@
       EXTERNAL HWRGEN
       B=P0(5)-P1(5)
       C=P2(5)+P3(5)+P4(5)+P5(5)
+#if !defined(CERNLIB_GFORTRAN)
       IF (B.LT.C) CALL HWWARN('HWDFIV',100,*999)
+#else
+      if (B.LT.C) then
+          call hwwarn('HWDFIV',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       AA=(P0(5)+P1(5))**2
       BB=B**2
       CC=C**2
diff -uNr src.ORIG/mclibs/herwig/code/hwdfor.F src/mclibs/herwig/code/hwdfor.F
--- src.ORIG/mclibs/herwig/code/hwdfor.F	1996-12-03 23:16:54.000000000 +0900
+++ src/mclibs/herwig/code/hwdfor.F	2005-05-31 02:34:21.000000000 +0900
@@ -11,7 +11,14 @@
       EXTERNAL HWRGEN
       B=P0(5)-P1(5)
       C=P2(5)+P3(5)+P4(5)
+#if !defined(CERNLIB_GFORTRAN)
       IF (B.LT.C) CALL HWWARN('HWDFOR',100,*999)
+#else
+      if (B.LT.C) then
+          call hwwarn('HWDFOR',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       AA=(P0(5)+P1(5))**2
       BB=B**2
       CC=C**2
diff -uNr src.ORIG/mclibs/herwig/code/hwdhad.F src/mclibs/herwig/code/hwdhad.F
--- src.ORIG/mclibs/herwig/code/hwdhad.F	1996-12-03 23:16:53.000000000 +0900
+++ src/mclibs/herwig/code/hwdhad.F	2005-05-31 02:34:40.000000000 +0900
@@ -7,6 +7,9 @@
 C     GENERATES DECAYS OF UNSTABLE HADRONS AND LEPTONS
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWRGEN,HWULDO,RN,BF,COSANG,RSUM,DIST(4),VERTX(4),
      & PMIX,WTMX,WTMX2,XS,DOT1,DOT2
       INTEGER IHEP,ID,MHEP,IDM,I,IDS,IM,MO,IPDG
@@ -21,7 +24,14 @@
      &  JDAHEP(1,IHEP).EQ.IHEP.AND.JDAHEP(2,IHEP).EQ.IHEP) THEN
 C---COPY COLOUR SINGLET CMF
         NHEP=NHEP+1
+#if !defined(CERNLIB_GFORTRAN)
         IF (NHEP.GT.NMXHEP) CALL HWWARN('HWDHAD',100,*999)
+#else
+        if (NHEP.GT.NMXHEP) then
+          call hwwarn('HWDHAD',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         CALL HWVEQU(5,PHEP(1,IHEP),PHEP(1,NHEP))
         CALL HWVEQU(4,VHEP(1,IHEP),VHEP(1,NHEP))
         IDHW(NHEP)=IDHW(IHEP)
@@ -78,7 +88,14 @@
                 IDM=ID
               ENDIF
 C Introduce a decaying neutral b-meson
+#if !defined(CERNLIB_GFORTRAN)
               IF (NHEP+1.GT.NMXHEP) CALL HWWARN('HWDHAD',101,*999)
+#else
+              if (NHEP+1.GT.NMXHEP) then
+          call hwwarn('HWDHAD',101,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
               MHEP=NHEP+1
               ISTHEP(MHEP)=ISTHEP(IHEP)
               ISTHEP(IHEP)=200
@@ -115,13 +132,25 @@
           DO 10 I=1,NMODES(IDM)
           BF=BF+BRFRAC(IM)
           IF (BF.GE.RN) GOTO 20
+#if !defined(CERNLIB_GFORTRAN)
   10      IM=LNEXT(IM)
+#else
+             IM=LNEXT(IM)
+  10      continue
+#endif
           CALL HWWARN('HWDHAD',50,*20)
   20      IF ((IDKPRD(1,IM).GE.1.AND.IDKPRD(1,IM).LE.13).OR.
      &        (IDKPRD(3,IM).GE.1.AND.IDKPRD(3,IM).LE.13)) THEN
 C Partonic decay of a heavy-(b,c)-hadron, store details
             NQDK=NQDK+1
+#if !defined(CERNLIB_GFORTRAN)
             IF (NQDK.GT.NMXQDK) CALL HWWARN('HWDHAD',102,*999)
+#else
+            if (NQDK.GT.NMXQDK) then
+          call hwwarn('HWDHAD',102,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
             LOCQ(NQDK)=MHEP
             IMQDK(NQDK)=IM
             CALL HWVEQU(4,VERTX,VTXQDK(1,NQDK))
@@ -129,7 +158,12 @@
           ELSE
 C Exclusive decay, add decay products to event record
             IF (NHEP+NPRODS(IM).GT.NMXHEP)
+#if !defined(CERNLIB_GFORTRAN)
      &        CALL HWWARN('HWDHAD',103,*999)
+#else
+     &        call hwwarn('HWDHAD',103,iret)
+        if (iret .eq. 1) go to 999
+#endif
             JDAHEP(1,MHEP)=NHEP+1
             DO 30 I=1,NPRODS(IM)
             NHEP=NHEP+1
@@ -139,7 +173,12 @@
             JMOHEP(1,NHEP)=MHEP
             JMOHEP(2,NHEP)=JMOHEP(2,MHEP)
             PHEP(5,NHEP)=RMASS(IDKPRD(I,IM))
+#if !defined(CERNLIB_GFORTRAN)
   30        CALL HWVEQU(4,VERTX,VHEP(1,NHEP))
+#else
+               CALL HWVEQU(4,VERTX,VHEP(1,NHEP))
+  30        continue
+#endif
             JDAHEP(2,MHEP)=NHEP
           ENDIF
 C Next choose momenta:
@@ -154,7 +193,12 @@
               MO=JMOHEP(1,MHEP)
               RSUM=0
               DO 40 I=1,3
+#if !defined(CERNLIB_GFORTRAN)
   40          RSUM=RSUM+RHOHEP(I,MO)
+#else
+                 RSUM=RSUM+RHOHEP(I,MO)
+  40          continue
+#endif
               IF (RSUM.GT.0) THEN
                 RSUM=RSUM*HWRGEN(3)
                 IF (RSUM.LT.RHOHEP(1,MO)) THEN
@@ -207,11 +251,21 @@
             CALL HWDFIV(PHEP(1,MHEP  ),PHEP(1,NHEP-4),PHEP(1,NHEP-3),
      &                  PHEP(1,NHEP-2),PHEP(1,NHEP-1),PHEP(1,NHEP))
           ELSE
+#if !defined(CERNLIB_GFORTRAN)
             CALL HWWARN('HWDHAD',104,*999)
+#else
+            call hwwarn('HWDHAD',104,iret)
+        if (iret .eq. 1) go to 999
+#endif
           ENDIF
         ENDIF
       ENDIF
   100 CONTINUE
 C---MAY HAVE OVERFLOWED /HEPEVT/
+#if !defined(CERNLIB_GFORTRAN)
       CALL HWWARN('HWDHAD',105,*999)
+#else
+      call hwwarn('HWDHAD',105,iret)
+        if (iret .eq. 1) go to 999
+#endif
   999 END
